## libxlsxwriter 1.2.3

=== CMakeLists.txt ===
#  :copyright: 2014-2025. John McNamara, Alex Huszagh.
#  :license: SPDX-License-Identifier: BSD-2-Clause

# CMake file for libxlsxwriter
# ============================
#
# To build libxlsxwriter with CMake move to a custom directory, ideally outside
# the root of the source tree, and type `cmake $LXW_SOURCE_LOCATION $FLAGS`,
# where `LXW_SOURCE_LOCATION` is the path to the libxlsxwriter project, and
# `FLAGS` are custom flags to pass to the compiler.
#
# For example, in the project directory, you can build libxlsxwriter as follows:
#
# ```
#     mkdir build
#     cd build
#
#     cmake .. -DCMAKE_BUILD_TYPE=Release
#     cmake --build . --config Release
#
# ```
#
# Or to build and run the tests (this can take several minutes):
#
# ```
#     mkdir build
#     cd build
#
#     cmake .. -DBUILD_TESTS=ON -DCMAKE_BUILD_TYPE=Release
#     cmake --build . --config Release
#     ctest -C Release -V
#     cmake --build . --config Release --target install
# ```
#
# If the tests run successfully, you can install the library as follows:
#
# ```
#     cmake --build . --config Release --target install
# ```
#
# The libxlsxwriter CMake options are shown below.

# ---------------------
# Project configuration
# ---------------------
cmake_minimum_required(VERSION 3.16)

set(XLSX_PROJECT_NAME
    "xlsxwriter"
    CACHE STRING
    "Libxlsxwriter is a C library for creating new Excel XLSX files"
)

set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
project(${XLSX_PROJECT_NAME} C)
enable_testing()

# -------------------
# Compilation options
# -------------------

# `USE_SYSTEM_MINIZIP`
#
# Libxlsxwriter uses the `minizip` component of `zlib`to create the xlsx zip
# file container. The vendored source files for `minizip` are included in the
# src tree of libxlsxwriter and are statically linked by default.
#
# You can use this option if you have the `minizip` library already installed on
# your system and prefer to dynamically link against it.
#
# To enable this option pass `-DUSE_SYSTEM_MINIZIP=ON` during configuration.
option(
    USE_SYSTEM_MINIZIP
    "Use system minizip library instead of the vendored copy"
    OFF
)

# `USE_STANDARD_TMPFILE`
#
# Uses the standard library `tmpfile` function to handle temp files instead of
# the vendored `tmpfileplus` function. Turning this off eliminates a dependency.
# This option is not recommended for Windows as it doesn't support a
# configurable location and the default location may be in a privileged
# directory.
#
# To enable this option pass `-DUSE_STANDARD_TMPFILE=ON` during configuration.
option(
    USE_STANDARD_TMPFILE
    "Use the C standard library tmpfile() instead of tmpfileplus"
    OFF
)

# `USE_OPENSSL_MD5`
#
# Uses OpenSSL to provide a MD5 digest of image files in order to avoid storing
# duplicates instead of the vendored OpenWall MD5 functions. This will link
# against libcrypto for MD5 support rather than using the local MD5 support.
#
# To enable this option pass `-DUSE_OPENSSL_MD5=ON` during configuration.
option(
    USE_OPENSSL_MD5
    "Build libxlsxwriter with the OpenSSL MD5 support instead of built in version"
    OFF
)

# `USE_NO_MD5`
#
# Compile without third party MD5 support. This will turn off the functionality
# of avoiding duplicate image files in the output xlsx file. This can reduce the
# executable size slightly if you aren't using images.
#
# To enable this option pass `-DUSE_NO_MD5=ON` during configuration.
option(
    USE_NO_MD5
    "Build libxlsxwriter without MD5 support for eliminating duplicate images"
    OFF
)

# `USE_DTOA_LIBRARY`
#
# Use the third party Milo Yip DTOA library to handle string formatting of
# doubles. This is used to avoid issues with double formatting in different
# locales and gives better performance with numeric data.
#
# To enable this library, pass `-DUSE_DTOA_LIBRARY=ON` during configuration.
option(
    USE_DTOA_LIBRARY
    "Use the Milo Yip DTOA library to handle string formatting of doubles."
    OFF
)

# `USE_MEM_FILE`
#
# Use in memory files instead of temp files using the
# `fmemopen()`/`open_memstream()` functions. This option isn't available with
# MSVC.
#
# To enable this option pass `-DUSE_MEM_FILE=ON` during configuration.
if(NOT MSVC)
    option(
        USE_MEM_FILE
        "Use fmemopen()/open_memstream() in place of temporary files"
        OFF
    )
endif()

# `BUILD_TESTS`
#
# Compile the unit and function tests for libxlsxwriter. This functional tests
# require the Python pytest library. The tests can be run with `ctest` after
# compilation. The uint tests do not work with MSVC and are turned off for that
# platform. Note, the tests can take a while to compile and run.
#
# To enable this option pass `-DBUILD_TESTS=ON` during configuration.
option(
    BUILD_TESTS
    "Build the libxlsxwriter unit and functional tests (requires pytest)"
    OFF
)

# TODO LXW_TARGET_BIG_ENDIAN

# `BUILD_EXAMPLES`
#
# Compile the libxlsxwriter example programs.
#
# To enable this option pass `-DBUILD_EXAMPLES=ON` during configuration.
option(BUILD_EXAMPLES "Build libxlsxwriter examples" OFF)

# `BUILD_FUZZERS`
#
# Compile the fuzzer harnesses.
#
# To enable this option pass `-DBUILD_FUZZERS=ON` during configuration.
option(BUILD_FUZZERS "Build harness(es) for fuzzing" OFF)

# `IOAPI_NO_64`
#
# Turn off `IOAPI_NO_64` support in minizip ioapi.c.
#
# To enable this option pass `-DIOAPI_NO_64=ON` during configuration.
option(IOAPI_NO_64 "Disable 64-bit filesystem support with minizip" OFF)

# `USE_STATIC_MSVC_RUNTIME`
#
# Compile as a static library with the static MSVC runtime library.
#
# To enable this option pass `-DUSE_STATIC_MSVC_RUNTIME=ON` during configuration.
if(MSVC)
    option(USE_STATIC_MSVC_RUNTIME "Use the static runtime library" OFF)
endif()

# `ZLIB_ROOT`
#
# The `ZLIB `root directory can be specified either through an environment
# variable (`export ZLIB_ROOT=/usr/include`) or using a flag with CMake
# (`-DZLIB_ROOT:STRING=/usr/include`). This sets the preferred search path for
# the ZLIB installation.
set(ZLIB_ROOT "" CACHE STRING "Optional root for the ZLIB installation")
if(DEFINED ENV{ZLIB_ROOT})
    set(ZLIB_ROOT $ENV{ZLIB_ROOT})
endif()

# -------------------------
# Configure the compilation
# -------------------------

if(USE_SYSTEM_MINIZIP)
    list(APPEND LXW_PRIVATE_COMPILE_DEFINITIONS USE_SYSTEM_MINIZIP)
endif()

if(USE_STANDARD_TMPFILE)
    list(APPEND LXW_PRIVATE_COMPILE_DEFINITIONS USE_STANDARD_TMPFILE)
endif()

if(NOT USE_OPENSSL_MD5 AND USE_NO_MD5)
    list(APPEND LXW_PRIVATE_COMPILE_DEFINITIONS USE_NO_MD5)
endif()

if(USE_OPENSSL_MD5)
    list(APPEND LXW_PRIVATE_COMPILE_DEFINITIONS USE_OPENSSL_MD5)
    if(NOT MSVC)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-deprecated-declarations")
    endif()
endif()

if(USE_MEM_FILE OR USE_FMEMOPEN)
    list(APPEND LXW_PRIVATE_COMPILE_DEFINITIONS USE_FMEMOPEN)
endif()

if(USE_DTOA_LIBRARY)
    list(APPEND LXW_PRIVATE_COMPILE_DEFINITIONS USE_DTOA_LIBRARY)
endif()

if(IOAPI_NO_64)
    list(APPEND LXW_PRIVATE_COMPILE_DEFINITIONS IOAPI_NO_64=1)
endif()

if(NOT BUILD_SHARED_LIBS)
    if(UNIX)
        set(CMAKE_POSITION_INDEPENDENT_CODE ON)
    elseif(MINGW OR MSYS)
        set(CMAKE_C_FLAGS
            "${CMAKE_C_FLAGS} -static -static-libgcc -Wno-char-subscripts -Wno-long-long"
        )
        list(APPEND LXW_PRIVATE_COMPILE_DEFINITIONS USE_FILE32API)
    elseif(MSVC)
        set(CMAKE_C_FLAGS_DEBUG
            "${CMAKE_C_FLAGS_DEBUG} /Fd\"${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pdb\""
        )
        set(CMAKE_C_FLAGS_RELEASE
            "${CMAKE_C_FLAGS_RELEASE} /Ox /Zi /Fd\"${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pdb\""
        )
        set(CMAKE_C_FLAGS_MINSIZEREL
            "${CMAKE_C_FLAGS_MINSIZEREL} /Zi /Fd\"${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pdb\""
        )
        set(CMAKE_C_FLAGS_RELWITHDEBINFO
            "${CMAKE_C_FLAGS_RELWITHDEBINFO} /Fd\"${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pdb\""
        )
    endif()
endif()

if(MSVC AND USE_STATIC_MSVC_RUNTIME)
    foreach(
        flag_var
        CMAKE_C_FLAGS
        CMAKE_C_FLAGS_DEBUG
        CMAKE_C_FLAGS_RELEASE
        CMAKE_C_FLAGS_MINSIZEREL
        CMAKE_C_FLAGS_RELWITHDEBINFO
    )
        if(${flag_var} MATCHES "/MD")
            string(REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
        endif()
    endforeach()
endif()

# -----------------------------
# Create the xlsxwriter.pc file
# -----------------------------
set(PREFIX ${CMAKE_INSTALL_PREFIX})

file(READ "include/xlsxwriter.h" ver)
string(REGEX MATCH "LXW_VERSION \"([^\"]+)\"" _ ${ver})
set(VERSION ${CMAKE_MATCH_1})
string(REGEX MATCH "LXW_SOVERSION \"([^\"]+)\"" _ ${ver})
set(SOVERSION ${CMAKE_MATCH_1})

set(ENABLED_OPTIONS "zlib")
if(USE_SYSTEM_MINIZIP)
    string(APPEND ENABLED_OPTIONS " minizip")
endif()
if(USE_OPENSSL_MD5)
    string(APPEND ENABLED_OPTIONS " libcrypto")
endif()

# Expand out the xlsxwriter.pc file.
configure_file(dev/release/pkg-config.txt xlsxwriter.pc @ONLY)

# ----------------
# Set the includes
# ----------------
enable_language(CXX)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# Set the zlib includes.
find_package(ZLIB "1.2.8" REQUIRED)
list(APPEND LXW_PRIVATE_INCLUDE_DIRS ${ZLIB_INCLUDE_DIRS})

# Set the minizip includes.
if(USE_SYSTEM_MINIZIP)
    if(MSVC)
        find_package(MINIZIP NAMES unofficial-minizip REQUIRED)
        set(MINIZIP_LIBRARIES unofficial::minizip::minizip)
    else()
        find_package(PkgConfig REQUIRED)
        pkg_check_modules(MINIZIP minizip)
        list(APPEND LXW_PRIVATE_INCLUDE_DIRS ${MINIZIP_INCLUDE_DIRS}/..)
    endif()
endif()

# Set the openssl includes.
if(USE_OPENSSL_MD5)
    find_package(OpenSSL REQUIRED)
    include_directories(${OPENSSL_INCLUDE_DIR})
endif()

# ----------------------------
# Set the library dependencies
# ----------------------------
list(APPEND LXW_PRIVATE_COMPILE_DEFINITIONS NOCRYPT NOUNCRYPT)

# Ensure CRT Secure warnings are disabled.
if(MSVC)
    list(APPEND LXW_PRIVATE_COMPILE_DEFINITIONS _CRT_SECURE_NO_WARNINGS)
endif()

# Ensure "TESTING" macro is defined if building tests.
if(BUILD_TESTS)
    list(APPEND LXW_PRIVATE_COMPILE_DEFINITIONS TESTING)
endif()

# Define "LXW_BIG_ENDIAN" macro on big-endian architectures.
include(TestBigEndian)
test_big_endian(LXW_TARGET_BIG_ENDIAN)
if(LXW_TARGET_BIG_ENDIAN)
    list(APPEND LXW_PRIVATE_COMPILE_DEFINITIONS LXW_BIG_ENDIAN)
endif()

# Set the source files.
file(GLOB LXW_SOURCES src/*.c)
file(GLOB_RECURSE LXW_HEADERS RELATIVE include *.h)

# If not using the system minizip, add the vendored minizip source files.
if(NOT USE_SYSTEM_MINIZIP)
    list(
        APPEND
        LXW_SOURCES
        third_party/minizip/ioapi.c
        third_party/minizip/zip.c
    )
    if(MSVC)
        list(APPEND LXW_SOURCES third_party/minizip/iowin32.c)
    endif()
endif()

# If not using the system tmpfile, add the vendored tmpfileplus files.
if(NOT USE_STANDARD_TMPFILE)
    list(APPEND LXW_SOURCES third_party/tmpfileplus/tmpfileplus.c)
endif()

if(NOT USE_OPENSSL_MD5 AND NOT USE_NO_MD5)
    list(APPEND LXW_SOURCES third_party/md5/md5.c)
endif()

if(USE_DTOA_LIBRARY)
    list(APPEND LXW_SOURCES third_party/dtoa/emyg_dtoa.c)
endif()

# Set project metadata.
set(LXW_PROJECT_DIR "${CMAKE_CURRENT_SOURCE_DIR}")
set(LXW_LIB_DIR "${LXW_PROJECT_DIR}/lib")
add_library(${PROJECT_NAME} "")
set_target_properties(${PROJECT_NAME} PROPERTIES SOVERSION ${SOVERSION})
target_sources(${PROJECT_NAME} PRIVATE ${LXW_SOURCES} PUBLIC ${LXW_HEADERS})

target_link_libraries(${PROJECT_NAME} PRIVATE ZLIB::ZLIB)

if(MINIZIP_LINK_LIBRARIES)
    target_link_libraries(${PROJECT_NAME} PRIVATE ${MINIZIP_LINK_LIBRARIES})
else()
    target_link_libraries(${PROJECT_NAME} PRIVATE ${MINIZIP_LIBRARIES})
endif()

target_link_libraries(
    ${PROJECT_NAME}
    PRIVATE ${LIB_CRYPTO} ${OPENSSL_CRYPTO_LIBRARY}
)

target_compile_definitions(
    ${PROJECT_NAME}
    PRIVATE ${LXW_PRIVATE_COMPILE_DEFINITIONS}
)

# Ensure MSVC supports /utf-8.
if(MSVC AND MSVC_VERSION GREATER_EQUAL 1900)

=== Makefile ===
###############################################################################
#
# Makefile for libxlsxwriter library.
#
# SPDX-License-Identifier: BSD-2-Clause
# Copyright 2014-2025, John McNamara, jmcnamara@cpan.org.
#

# Keep the output quiet by default.
Q=@
ifdef V
Q=
endif

DESTDIR ?=
PREFIX  ?= /usr/local

PYTEST ?= py.test
PYTESTFILES ?= test

VERSION   = $(shell sed -n -e 's/.*LXW_VERSION \"\(.*\)\"/\1/p'   include/xlsxwriter.h)
SOVERSION = $(shell sed -n -e 's/.*LXW_SOVERSION \"\(.*\)\"/\1/p' include/xlsxwriter.h)

ENABLED_OPTIONS = zlib
ifdef USE_SYSTEM_MINIZIP
    ENABLED_OPTIONS += minizip
endif
ifdef USE_OPENSSL_MD5
	ENABLED_OPTIONS += libcrypto
endif

.PHONY: docs tags examples third_party

# Build libxlsxwriter.
all : third_party
	$(Q)$(MAKE) -C src

# Build the third party libs.
third_party :
ifndef USE_SYSTEM_MINIZIP
	$(Q)$(MAKE) -C third_party/minizip
endif
ifndef USE_STANDARD_TMPFILE
	$(Q)$(MAKE) -C third_party/tmpfileplus
endif
ifndef USE_NO_MD5
ifndef USE_OPENSSL_MD5
	$(Q)$(MAKE) -C third_party/md5
endif
endif
ifdef USE_DTOA_LIBRARY
	$(Q)$(MAKE) -C third_party/dtoa
endif

# Build a macOS universal binary.
universal_binary :
	$(Q)$(MAKE) clean
	$(Q)TARGET_ARCH="-target x86_64-apple-macos10.12" $(MAKE) all
	$(Q)mv lib/libxlsxwriter.a     libxlsxwriter_x86_64.a
	$(Q)mv lib/libxlsxwriter.$(SOVERSION).dylib libxlsxwriter_x86_64.dylib

	$(Q)$(MAKE) clean
	$(Q)TARGET_ARCH="-target arm64-apple-macos11" $(MAKE) all
	$(Q)mv lib/libxlsxwriter.a     lib/libxlsxwriter_arm64.a
	$(Q)mv lib/libxlsxwriter.$(SOVERSION).dylib lib/libxlsxwriter_arm64.dylib
	$(Q)mv libxlsxwriter_x86_64.a libxlsxwriter_x86_64.dylib lib

	$(Q)lipo -create -output lib/libxlsxwriter.a                  lib/libxlsxwriter_x86_64.a     lib/libxlsxwriter_arm64.a
	$(Q)lipo -create -output lib/libxlsxwriter.$(SOVERSION).dylib lib/libxlsxwriter_x86_64.dylib lib/libxlsxwriter_arm64.dylib
	$(Q)rm -f lib/libxlsxwriter_x86_64.* lib/libxlsxwriter_arm64.*

# Build the example programs.
examples : all
	$(Q)$(MAKE) -C examples

# Build the example programs with CPP for compatibility checking.
examples_cpp : all
	$(Q)$(MAKE) -C examples CC=$(CXX)

# Clean src and test directories.
clean :
	$(Q)$(MAKE) clean -C src
	$(Q)$(MAKE) clean -C test/unit
	$(Q)$(MAKE) clean -C test/functional/src
	$(Q)$(MAKE) clean -C test/cpp
	$(Q)$(MAKE) clean -C examples
	$(Q)rm -rf docs/html
	$(Q)rm -rf test/functional/__pycache__
	$(Q)rm -f  test/functional/*.pyc
	$(Q)rm -f  lib/*
	$(Q)$(MAKE) clean -C third_party/minizip
	$(Q)$(MAKE) clean -C third_party/tmpfileplus
	$(Q)$(MAKE) clean -C third_party/md5
	$(Q)$(MAKE) clean -C third_party/dtoa

# Clean src and lib dir only, as a precursor for static analysis.
clean_src :
	$(Q)$(MAKE) clean -C src
	$(Q)rm -f  lib/*

# Run the unit tests.
test : all test_cpp test_unit test_functional

# Test for C++ const correctness on APIs.
test_const : all
	$(Q)$(MAKE) clean -C test/functional/src
	$(Q)! $(MAKE) -C test/functional/src CFLAGS=-Wwrite-strings 2>&1 | grep -A 1 "note:"


# Run the functional tests.
test_functional : all
	$(Q)$(MAKE) -C test/functional/src
	$(Q)$(PYTEST) test/functional -v -k $(PYTESTFILES)

# Run all tests.
test_unit : all
	$(Q)$(MAKE) -C src test_lib
	$(Q)$(MAKE) -C test/unit test

# Test C++ compilation.
test_cpp : all
	$(Q)$(MAKE) -C test/cpp

# Test Cmake. This test should really be done with Cmake in the cmake dir but
# this is a workaround for now.
test_cmake :
ifneq ($(findstring m32,$(CFLAGS)),m32)
	$(Q)$(MAKE) -C src clean
	$(Q)mkdir -p build
	$(Q)cd build
	$(Q)cmake .. -DBUILD_TESTS=ON -DBUILD_EXAMPLES=ON
	$(Q)make clean; make; cp libxlsxwriter.a ../src/
	$(Q)cmake/xlsxwriter_unit
	$(Q)$(MAKE) -C test/functional/src
	$(Q)$(PYTEST) test/functional -v -k $(PYTESTFILES)
else
	@echo "Skipping Cmake tests on 32 bit target."
endif

# Test the functional test exes with valgrind (in 64bit mode only).
test_valgrind : all
ifndef NO_VALGRIND
	$(Q)$(MAKE) -C test/functional/src test_valgrind
	$(Q)$(MAKE) -C examples test_valgrind
endif

# Minimal target for quick compile without creating the libs.
test_compile :
	$(Q)$(MAKE) -C src	test_compile

# Indent the source files with the .indent.pro settings.
indent:
	$(Q)gindent src/*.c include/*.h include/xlsxwriter/*.h
	$(Q)gersemi --no-warn-about-unknown-commands -i CMakeLists.txt

tags:
	$(Q)rm -f TAGS
	$(Q)etags src/*.c include/*.h include/xlsxwriter/*.h

# Build the doxygen docs.
doc: docs
docs:
	$(Q)$(MAKE) -C docs
	@echo "Docs built."

docs_doxygen_only:
	$(Q)$(MAKE) -C docs docs_doxygen_only

docs_external:
	$(Q)make -C ../libxlsxwriter.github.io release

# Simple install.
install: all
	$(Q)mkdir -p        $(DESTDIR)$(PREFIX)/include
	$(Q)cp -R include/* $(DESTDIR)$(PREFIX)/include
	$(Q)mkdir -p        $(DESTDIR)$(PREFIX)/lib
	$(Q)cp -R lib/*     $(DESTDIR)$(PREFIX)/lib
	$(Q)mkdir -p        $(DESTDIR)$(PREFIX)/lib/pkgconfig
	$(Q)sed             -e 's|@PREFIX@|$(PREFIX)|g'                   \
	                    -e 's|@VERSION@|$(VERSION)|g'                 \
	                    -e 's|@ENABLED_OPTIONS@|$(ENABLED_OPTIONS)|g' \
	                        dev/release/pkg-config.txt                \
	                        > $(DESTDIR)$(PREFIX)/lib/pkgconfig/xlsxwriter.pc

# Simpler uninstall.
uninstall:
	$(Q)rm -rf $(DESTDIR)$(PREFIX)/include/xlsxwriter*
	$(Q)rm     $(DESTDIR)$(PREFIX)/lib/libxlsxwriter.*
	$(Q)rm     $(DESTDIR)$(PREFIX)/lib/pkgconfig/xlsxwriter.pc

# Strip the lib files.
strip:
	$(Q)strip lib/*

# Run a coverity static analysis.
coverity: clean_src third_party
	$(Q)rm -rf  cov-int
	$(Q)rm -f libxlsxwriter-coverity.tgz
	$(Q)../../cov-analysis-linux64-2019.03/bin/cov-build --dir cov-int make -C src libxlsxwriter.a
	$(Q)tar -czf libxlsxwriter-coverity.tgz cov-int
	$(Q)$(MAKE) -C src clean
	$(Q)rm -f  lib/*

# Run address sanitiser.
address_sanitiser: third_party
	$(Q)$(MAKE) -C src libxlsxwriter.a CFLAGS="-fsanitize=address -O1 -fsanitize-coverage=trace-pc-guard -fno-omit-frame-pointer -g"
	$(Q)$(MAKE) -C examples            CFLAGS="-fsanitize=address -O1 -fsanitize-coverage=trace-pc-guard -fno-omit-frame-pointer -g"

# Run gcov coverage analysis.
gcov: third_party
	$(Q)$(MAKE) -C src clean
	$(Q)$(MAKE) -C src                 GCOV="--coverage" OPT_LEVEL="-O0"
	$(Q)$(MAKE) -C src test_lib        GCOV="--coverage"
	$(Q)$(MAKE) -C test/unit test      GCOV="--coverage"
	$(Q)$(MAKE) -C test/functional/src GCOV="--coverage"
	$(Q)$(PYTEST) test/functional -v -k $(PYTESTFILES)
	$(Q)mkdir -p build
	$(Q)gcovr -r src --html-details -o build/libxlsxwriter_gcov.html
	$(Q)gcovr -r . -f src --sonarqube build/coverage.xml

# Run sonarcloud analysis.
sonarcloud: gcov
ifndef SONAR_TOKEN
	@echo "Please define SONAR_TOKEN to run this analysis."
	@exit 1
endif
	$(Q)$(MAKE) clean
	$(Q)../sonar-scanner-4.6.1.2450-macosx/bin/build-wrapper-macosx-x86 --out-dir build make all
	$(Q)../sonar-scanner-4.6.1.2450-macosx/bin/sonar-scanner \
        -Dsonar.organization=jmcnamara-github \
        -Dsonar.projectKey=jmcnamara_libxlsxwriter \
        -Dsonar.projectName=libxlsxwriter \
        -Dsonar.projectVersion=$(VERSION) \
        -Dsonar.sources=src \
        -Dsonar.sourceEncoding=UTF-8 \
        -Dsonar.cfamily.build-wrapper-output=build \
        -Dsonar.working.directory=build/scannerwork \
        -Dsonar.host.url=https://sonarcloud.io \
        -Dsonar.coverageReportPaths=build/coverage.xml

sonarcloud_no_gcov:
ifndef SONAR_TOKEN
	@echo "Please define SONAR_TOKEN to run this analysis."
	@exit 1
endif
	$(Q)$(MAKE) clean
	$(Q)../sonar-scanner-4.6.1.2450-macosx/bin/build-wrapper-macosx-x86 --out-dir build make all
	$(Q)../sonar-scanner-4.6.1.2450-macosx/bin/sonar-scanner \
        -Dsonar.organization=jmcnamara-github \
        -Dsonar.projectKey=jmcnamara_libxlsxwriter \
        -Dsonar.projectName=libxlsxwriter \
        -Dsonar.projectVersion=$(VERSION) \
        -Dsonar.sources=src \
        -Dsonar.sourceEncoding=UTF-8 \
        -Dsonar.cfamily.build-wrapper-output=build \
        -Dsonar.working.directory=build/scannerwork \
        -Dsonar.host.url=https://sonarcloud.io


# Run a scan-build static analysis.
scan_build: clean_src third_party
	$(Q)scan-build make -C src libxlsxwriter.a
	$(Q)$(MAKE) -C src clean
	$(Q)rm -f  lib/*

spellcheck:
	$(Q)for f in docs/src/*.dox;         do aspell --lang=en_US --check $$f; done
	$(Q)for f in include/xlsxwriter/*.h; do aspell --lang=en_US --check $$f; done
	$(Q)for f in src/*.c;                do aspell --lang=en_US --check $$f; done
	$(Q)for f in examples/*.c;           do aspell --lang=en_US --check $$f; done
	$(Q)aspell --lang=en_US --check Changes.txt
	$(Q)aspell --lang=en_US --check Readme.md
	$(Q)aspell --lang=en_US --check docs/src/examples.txt

releasecheck:
	$(Q)dev/release/release_check.sh

release: releasecheck
	@echo
	@echo "Pushing to git main ..."
	$(Q)git push origin main
	$(Q)git push --tags

	@echo
	@echo "Pushing updated docs ..."
	$(Q)make -C ../libxlsxwriter.github.io release

	@echo
	@echo "Pushing the cocoapod ..."
	$(Q)pod trunk push libxlsxwriter.podspec --use-libraries

	@echo
	@echo "Finished. Opening files."
	$(Q)open https://libxlsxwriter.github.io/changes.html
	$(Q)open https://cocoadocs.org/docsets/libxlsxwriter
	$(Q)open https://github.com/jmcnamara/libxlsxwriter
	$(Q)open https://github.com/jmcnamara/libxlsxwriter/releases

=== docs/Makefile ===
###############################################################################
#
# Makefile for libxlsxwriter library.
#
# SPDX-License-Identifier: BSD-2-Clause
# Copyright 2014-2025, John McNamara, jmcnamara@cpan.org.
#

# Keep the output quiet by default.
Q=@
ifdef V
Q=
endif

# Make everything.
all : docs

# Clean up.
clean :
	$(Q)rm -rf html/*

# Build the doxygen docs.
docs:
	$(Q)perl ../dev/release/fix_example_links.pl src/examples.txt > src/examples.dox
	$(Q)doxygen
	$(Q)../dev/release/fix_dox.sh

docs_doxygen_only:
	$(Q)doxygen

=== examples/Makefile ===
###############################################################################
#
# Makefile for libxlsxwriter examples.
#
# Copyright 2014-2025, John McNamara, jmcnamara@cpan.org
#

# Keep the output quiet by default.
Q=@
ifdef V
Q=
endif

# Directory variables.
INC_DIR = ../include

# Flags passed to the C++ compiler.
CFLAGS += -g -Wall -Wextra

# Source files to compile.
SRCS = $(wildcard *.c)
EXES = $(patsubst %.c,%,$(SRCS))

LIBXLSXWRITER = ../src/libxlsxwriter.a

LIBS = $(LIBXLSXWRITER) -lz
ifdef USE_SYSTEM_MINIZIP
LIBS += -lminizip
endif
ifdef USE_OPENSSL_MD5
LIBS += -lcrypto
endif

all : $(LIBXLSXWRITER) $(EXES)

$(LIBXLSXWRITER):
	$(Q)$(MAKE) -C ../third_party/minizip
ifndef USE_STANDARD_TMPFILE
	$(Q)$(MAKE) -C ../third_party/tmpfileplus
endif
ifndef USE_STANDARD_DOUBLE
	$(Q)$(MAKE) -C ../third_party/dtoa
endif
ifndef USE_NO_MD5
	$(Q)$(MAKE) -C ../third_party/md5
endif
	$(Q)$(MAKE) -C ../src

clean :
	$(Q)rm -f $(EXES)

# Executable targets.
%: %.c $(LIBXLSXWRITER)
	$(Q)$(CC) -I$(INC_DIR) $(CFLAGS) $< -o $@ $(LIBS)

test_valgrind: all
	$(Q)$(foreach exe,$(EXES),valgrind -q --error-exitcode=1 --leak-check=full ./$(exe) || exit;)

=== src/Makefile ===
###############################################################################
#
# Makefile for libxlsxwriter library.
#
# SPDX-License-Identifier: BSD-2-Clause
# Copyright 2014-2025, John McNamara, jmcnamara@cpan.org.
#

# Keep the output quiet by default.
Q=@
ifdef V
Q=
endif

DESTDIR ?=
PREFIX  ?= /usr/local
OPT_LEVEL ?= -O3

SOVERSION = $(shell sed -n -e 's/.*LXW_SOVERSION \"\(.*\)\"/\1/p' ../include/xlsxwriter.h)


# Directory variables.
OBJS_DIR    = .
INC_DIR     = ../include

LIBS = -lz

ifdef USE_SYSTEM_MINIZIP
LIBS   += -lminizip
CFLAGS += -DUSE_SYSTEM_MINIZIP
else
# Use the local copy of minizip.
MINIZIP_DIR = ../third_party/minizip
MINIZIP_OBJ = $(MINIZIP_DIR)/ioapi.o  $(MINIZIP_DIR)/zip.o
MINIZIP_SO  = $(MINIZIP_DIR)/ioapi.so $(MINIZIP_DIR)/zip.so
endif

ifdef USE_STANDARD_TMPFILE
# Use standard/C tmpfile().
CFLAGS += -DUSE_STANDARD_TMPFILE
else
# Use tmpfileplus (the default).
TMPFILEPLUS_DIR = ../third_party/tmpfileplus
TMPFILEPLUS_OBJ = $(TMPFILEPLUS_DIR)/tmpfileplus.o
TMPFILEPLUS_SO  = $(TMPFILEPLUS_DIR)/tmpfileplus.so
endif

ifdef USE_NO_MD5
# Don't use MD5 to avoid duplicate image files.
CFLAGS += -DUSE_NO_MD5
else
ifdef USE_OPENSSL_MD5
CFLAGS += -DUSE_OPENSSL_MD5 -Wno-deprecated-declarations
LIBS   += -lcrypto
else
# Use md5 (the default).
MD5_DIR = ../third_party/md5
MD5_OBJ = $(MD5_DIR)/md5.o
MD5_SO  = $(MD5_DIR)/md5.so
endif
endif

# Set flag for big endian architecture.
ifdef USE_BIG_ENDIAN
CFLAGS += -DLXW_BIG_ENDIAN
endif

# Use a third party double number formatting function.
ifdef USE_DTOA_LIBRARY
CFLAGS += -DUSE_DTOA_LIBRARY
DTOA_LIB_DIR = ../third_party/dtoa
DTOA_LIB_OBJ = $(DTOA_LIB_DIR)/emyg_dtoa.o
DTOA_LIB_SO  = $(DTOA_LIB_DIR)/emyg_dtoa.so
endif

# Use fmemopen()/open_memstream() to avoid creating temporary files
ifdef USE_MEM_FILE
USE_FMEMOPEN = 1
endif

ifdef USE_FMEMOPEN
CFLAGS += -DUSE_FMEMOPEN
endif

# Flags passed to compiler.
CFLAGS   += -g $(OPT_LEVEL) -Wall -Wextra -Wstrict-prototypes -pedantic -ansi

# Ignore icc remarks about inlining limits.
ifeq ($(CC),icc)
CFLAGS   +=-diag-disable=11074,11076
endif

# Library names.
LIBXLSXWRITER_A  = libxlsxwriter.a
LIBXLSXWRITER_SO = libxlsxwriter.so.$(SOVERSION)

# Library with additional non-static functions for testing.
LIBXLSXWRITER_TO = libxlsxwriter_test.a

# Flags passed to static linker.
ARFLAGS = rc

# Flags passed to dynamic linker.
FPIC = -fPIC
SOFLAGS = -shared $(FPIC) -Wl,-soname,$(LIBXLSXWRITER_SO)

# Get Env/OS name.
UNAME := $(shell uname)

# Change make options on OS X.
ifeq ($(UNAME), Darwin)
LIBXLSXWRITER_SO = libxlsxwriter.$(SOVERSION).dylib
SOFLAGS = -dynamiclib $(FPIC) -compatibility_version $(SOVERSION) -install_name $(PREFIX)/lib/$(LIBXLSXWRITER_SO) $(GCOV)
endif

# Check for MinGW/MinGW64/Cygwin environments.
ifneq (,$(findstring MINGW, $(UNAME)))
MING_LIKE = y
endif
ifneq (,$(findstring MSYS, $(UNAME)))
MING_LIKE = y
endif
ifneq (,$(findstring CYGWIN, $(UNAME)))
MING_LIKE = y
endif

# Change make options on MinGW/MinGW64/Cygwin.
ifdef MING_LIKE
LIBXLSXWRITER_SO = libxlsxwriter.dll
FPIC =
CC = gcc
CFLAGS += -Wno-char-subscripts -Wno-long-long
endif

# Headers as dependecies.
HDRS = $(wildcard ../include/xlsxwriter/*.h)

# Ojects to compile.
SRCS  = $(wildcard *.c)
OBJS  = $(patsubst %.c,%.o,$(SRCS))
SOBJS = $(patsubst %.c,%.so,$(SRCS))
TOBJS = $(patsubst %.c,%.to,$(SRCS))
# End of OBJS

# Build the object files and the libraries.
all : $(LIBXLSXWRITER_A) $(LIBXLSXWRITER_SO)
	$(Q)cp $(LIBXLSXWRITER_A) $(LIBXLSXWRITER_SO) ../lib

ifeq ($(UNAME), Darwin)
	$(Q)rm -f ../lib/libxlsxwriter.dylib
	$(Q)ln -s $(LIBXLSXWRITER_SO) ../lib/libxlsxwriter.dylib
endif

ifneq ($(UNAME), Darwin)
	$(Q)rm -f ../lib/libxlsxwriter.so
	$(Q)ln -s $(LIBXLSXWRITER_SO) ../lib/libxlsxwriter.so
endif

test_lib : libxlsxwriter_test.a

# The static library.
$(LIBXLSXWRITER_A) : $(OBJS)
	$(Q)$(AR) $(ARFLAGS) $@ $(MINIZIP_OBJ) $(TMPFILEPLUS_OBJ) $(DTOA_LIB_OBJ) $(MD5_OBJ) $^

# The dynamic library.
ifeq ($(findstring m32,$(CFLAGS)),m32)
ARCH = -m32
endif

$(LIBXLSXWRITER_SO) : $(SOBJS)
	$(Q)$(CC) $(LDFLAGS) $(SOFLAGS) $(ARCH) $(TARGET_ARCH) -o $@ $(MINIZIP_SO) $(TMPFILEPLUS_SO) $(MD5_SO) $(DTOA_LIB_SO) $^ $(LIBS)

# The test library.
$(LIBXLSXWRITER_TO) : $(TOBJS)
	$(Q)$(AR) $(ARFLAGS) $@ $(MINIZIP_OBJ) $(TMPFILEPLUS_OBJ) $(DTOA_LIB_SO) $(MD5_OBJ) $^

# Minimal target for quick compile without creating the libs.
test_compile : $(OBJS)

# Targets for the object files.
%.o  : %.c $(HDRS)
	$(Q)$(CC) -I$(INC_DIR) $(CFLAGS) $(CXXFLAGS) $(TARGET_ARCH) $(GCOV) -c $<

%.so : %.c $(HDRS)
	$(Q)$(CC) $(FPIC) -I$(INC_DIR) $(CFLAGS) $(CXXFLAGS) $(TARGET_ARCH) $(GCOV) -c $< -o $@

%.to : %.c $(HDRS)
	$(Q)$(CC) -g $(OPT_LEVEL) -DTESTING -I$(INC_DIR) $(CFLAGS) $(CXXFLAGS) $(GCOV) -c $< -o $@


# Clean up any temp/build files.
clean :
	$(Q)rm -f *.o *.a *.so *.so.* *.to *.dylib *.dll *.gcno *.gcda

=== dev/fuzzing/CMakeLists.txt ===
# Utilized by OSSFuzz to build the harness(es) for continuous fuzz-testing
# OSSFuzz defines the following environment variables, that this target relies upon:
# CXX, CFLAGS, LIB_FUZZING_ENGINE, OUT

add_definitions(-DNDEBUG)  # Do not want assertions

if (DEFINED ENV{CFLAGS})
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} $ENV{CFLAGS}")
endif()
if (DEFINED ENV{CXXFLAGS})
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} $ENV{CXXFLAGS}")
endif()


add_executable(xlsx_fuzzer xlsx_fuzzer.cpp)
target_link_libraries(xlsx_fuzzer PRIVATE ${PROJECT_NAME} $ENV{LIB_FUZZING_ENGINE})
target_compile_features(xlsx_fuzzer PRIVATE cxx_std_17)

if (DEFINED ENV{OUT})
    install(TARGETS xlsx_fuzzer DESTINATION $ENV{OUT})
else ()
    message(WARNING "Cannot install if $OUT is not defined!")
endif ()

=== test/cpp/Makefile ===
###############################################################################
#
# Makefile for libxlsxwriter testcase.
#
# SPDX-License-Identifier: BSD-2-Clause
# Copyright 2014-2025, John McNamara, jmcnamara@cpan.org.
#

# Keep the output quiet by default.
Q=@
ifdef V
Q=
endif

# Directory variables.
INC_DIR = ../../include

# Flags passed to the C++ compiler.
CXXFLAGS += -g -Wall -Wextra

# Source files to compile.
SRCS = $(wildcard *.cpp)
EXES = $(patsubst %.cpp,%,$(SRCS))

LIBXLSXWRITER = ../../src/libxlsxwriter.a
LIBS = $(LIBXLSXWRITER) -lz

ifdef USE_SYSTEM_MINIZIP
LIBS += -lminizip
endif

ifdef USE_OPENSSL_MD5
LIBS += -lcrypto
endif

all : $(LIBXLSXWRITER) $(EXES)

$(LIBXLSXWRITER):
	$(Q)$(MAKE) -C ../.. all

clean :
	$(Q)rm -f $(EXES)

# Executable targets.
%: %.cpp $(LIBXLSXWRITER)
	$(Q)$(CXX) -I$(INC_DIR) $(CXXFLAGS) $(LDFLAGS) $< -o $@ $(LIBS)

=== test/unit/Makefile ===
###############################################################################
#
# Makefile for libxlsxwriter library.
#
# SPDX-License-Identifier: BSD-2-Clause
# Copyright 2014-2025, John McNamara, jmcnamara@cpan.org.
#

# Keep the output quiet by default.
Q=@
ifdef V
Q=
endif

# Directory variables.
INC_DIR        = ../../include
LIB_DIR        = ../../src

# Flags passed to the C compiler.
CFLAGS += -DTESTING -DCOLOR_OK -g -Wall -Wextra -Wno-unused-parameter $(GCOV)


# All tests produced by this Makefile.
TESTS = test_all

# Objects to link for test_all executable.
SRCS  = $(wildcard utility/test*.c)
SRCS += $(wildcard xmlwriter/test*.c)
SRCS += $(wildcard worksheet/test*.c)
SRCS += $(wildcard sst/test*.c)
SRCS += $(wildcard workbook/test*.c)
SRCS += $(wildcard app/test*.c)
SRCS += $(wildcard content_types/test*.c)
SRCS += $(wildcard core/test*.c)
SRCS += $(wildcard relationships/test*.c)
SRCS += $(wildcard format/test*.c)
SRCS += $(wildcard styles/test*.c)
SRCS += $(wildcard drawing/test*.c)
SRCS += $(wildcard chart/test*.c)
SRCS += $(wildcard custom/test*.c)
SRCS += $(wildcard chartsheet/test*.c)
SRCS += $(wildcard vml/test*.c)
SRCS += $(wildcard comment/test*.c)
SRCS += $(wildcard metadata/test*.c)
SRCS += $(wildcard table/test*.c)
SRCS += $(wildcard rich_value/test*.c)
SRCS += $(wildcard rich_value_rel/test*.c)
SRCS += $(wildcard rich_value_types/test*.c)
SRCS += $(wildcard rich_value_structure/test*.c)
# End of SRCS

OBJS  = $(patsubst %.c,%.o,$(SRCS))

# Libs to link.
LIBS_A = $(LIB_DIR)/libxlsxwriter_test.a
LIBS_O = -lz
ifdef USE_SYSTEM_MINIZIP
LIBS_O += -lminizip
CFLAGS += -DUSE_SYSTEM_MINIZIP
endif
ifdef USE_OPENSSL_MD5
LIBS_O += -lcrypto
endif

# End of LIBS

# House-keeping build targets.
all :
	$(Q)$(MAKE) -C utility
	$(Q)$(MAKE) -C xmlwriter
	$(Q)$(MAKE) -C worksheet
	$(Q)$(MAKE) -C sst
	$(Q)$(MAKE) -C workbook
	$(Q)$(MAKE) -C app
	$(Q)$(MAKE) -C content_types
	$(Q)$(MAKE) -C core
	$(Q)$(MAKE) -C relationships
	$(Q)$(MAKE) -C styles
	$(Q)$(MAKE) -C drawing
	$(Q)$(MAKE) -C chart
	$(Q)$(MAKE) -C custom
	$(Q)$(MAKE) -C chartsheet
	$(Q)$(MAKE) -C vml
	$(Q)$(MAKE) -C comment
	$(Q)$(MAKE) -C metadata
	$(Q)$(MAKE) -C table
	$(Q)$(MAKE) -C rich_value
	$(Q)$(MAKE) -C rich_value_rel
	$(Q)$(MAKE) -C rich_value_types
	$(Q)$(MAKE) -C rich_value_structure
# END make all

clean :
	$(Q)rm -f $(TESTS) test_all *.o *.gcno *.gcda
	$(Q)$(MAKE) clean -C utility
	$(Q)$(MAKE) clean -C xmlwriter
	$(Q)$(MAKE) clean -C worksheet
	$(Q)$(MAKE) clean -C sst
	$(Q)$(MAKE) clean -C workbook
	$(Q)$(MAKE) clean -C app
	$(Q)$(MAKE) clean -C content_types
	$(Q)$(MAKE) clean -C core
	$(Q)$(MAKE) clean -C relationships
	$(Q)$(MAKE) clean -C styles
	$(Q)$(MAKE) clean -C drawing
	$(Q)$(MAKE) clean -C chart
	$(Q)$(MAKE) clean -C custom
	$(Q)$(MAKE) clean -C chartsheet
	$(Q)$(MAKE) clean -C vml
	$(Q)$(MAKE) clean -C comment
	$(Q)$(MAKE) clean -C metadata
	$(Q)$(MAKE) clean -C table
	$(Q)$(MAKE) clean -C rich_value
	$(Q)$(MAKE) clean -C rich_value_rel
	$(Q)$(MAKE) clean -C rich_value_types
	$(Q)$(MAKE) clean -C rich_value_structure
# END make clean


###############################################################################
#
# Builds the tests.
#
test_all : test_all.o $(OBJS) $(LIBS_A)
	$(Q)$(CC) $(CFLAGS) $(LDFLAGS) -I$(INC_DIR) -o $@ $^ $(LIBS_O)


###############################################################################
#
# Run the tests.
#
test : all test_all
	$(Q)./test_all

=== test/unit/rich_value/Makefile ===
###############################################################################
#
# Makefile for libxlsxwriter library.
#
# Copyright 2014-2015, John McNamara, jmcnamara@cpan.org
#

include ../Makefile.unit

=== test/unit/table/Makefile ===
###############################################################################
#
# Makefile for libxlsxwriter library.
#
# Copyright 2014-2025, John McNamara, jmcnamara@cpan.org
#

include ../Makefile.unit

=== debian/changelog ===
libxlsxwriter (1.2.3-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Wed, 13 Aug 2025 15:18:20 -0400

libxlsxwriter (1.2.3-1~exp1) experimental; urgency=medium

  * New upstream release.
  * SONAME bump: libxlsxwriter8 => libxlsxwriter10.
  * debian/libxlsxwriter10.symbols: Updated.

 -- Boyuan Yang <byang@debian.org>  Tue, 12 Aug 2025 13:34:33 -0400

libxlsxwriter (1.2.1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Sun, 02 Mar 2025 22:22:20 -0500

libxlsxwriter (1.2.1-1~exp2) experimental; urgency=medium

  * New upstream release.
  * debian/control: Add explicit binary dep libssl-dev.

 -- Boyuan Yang <byang@debian.org>  Sun, 02 Mar 2025 14:16:35 -0500

=== debian/control ===
Source: libxlsxwriter
Section: libs
Priority: optional
Maintainer: Ma Aiguo <imaiguo@gmail.com>
Uploaders:
 Boyuan Yang <byang@debian.org>,
 Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>,
Build-Depends: dpkg-dev (>= 1.22.5),
 cmake,
 debhelper-compat (= 13),
 libminizip-dev,
 libssl-dev,
 pkgconf,
 python3-dev,
 python3-pytest <!nocheck>,
 zlib1g-dev,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/jmcnamara/libxlsxwriter
Vcs-Git: https://salsa.debian.org/debian/libxlsxwriter.git
Vcs-Browser: https://salsa.debian.org/debian/libxlsxwriter
Description: Library for XLSX
 Libxlsxwriter is a C library that can be used
 to write text, numbers, formulas and hyperlinks to multiple
 worksheets in an Excel 2007+ XLSX file.

Package: libxlsxwriter-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libssl-dev,
 libxlsxwriter10 (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} -- development library of xlsxwriter
 ${source:Extended-Description}
 .
 This package contains the header file and development library of
 xlsxwriter.

Package: libxlsxwriter10
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} -- runtime library
 ${source:Extended-Description}
 .
 This package contains the runtime and shared library of xlsxwriter.

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CXXFLAGS += $(CPPFLAGS)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DBUILD_SHARED_LIBS=ON \
	    -DUSE_SYSTEM_MINIZIP=ON \
	    -DUSE_OPENSSL_MD5=ON \
	    -DBUILD_TESTS=ON \
	    -DBUILD_EXAMPLES=ON \
	    $(EXTRA_CONFIG_FLAGS)

=== debian/watch ===
version=4
opts="filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,searchmode=plain" \
 https://api.github.com/repos/jmcnamara/libxlsxwriter/tags?per_page=100 \
 https://api.github.com/repos/jmcnamara/libxlsxwriter/tarball/refs/tags/@ANY_VERSION@

## libxlsxwriter 1.2.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-#  :copyright: 2014-2025. John McNamara, Alex Huszagh.
+#  :copyright: 2014-2026. John McNamara, Alex Huszagh.
 #  :license: SPDX-License-Identifier: BSD-2-Clause
 
 # CMake file for libxlsxwriter
@@ -354,8 +354,7 @@
 # If not using the system minizip, add the vendored minizip source files.
 if(NOT USE_SYSTEM_MINIZIP)
     list(
-        APPEND
-        LXW_SOURCES
+        APPEND LXW_SOURCES
         third_party/minizip/ioapi.c
         third_party/minizip/zip.c
     )

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Makefile for libxlsxwriter library.
 #
 # SPDX-License-Identifier: BSD-2-Clause
-# Copyright 2014-2025, John McNamara, jmcnamara@cpan.org.
+# Copyright 2014-2026, John McNamara, jmcnamara@cpan.org.
 #
 
 # Keep the output quiet by default.

=== docs/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Makefile for libxlsxwriter library.
 #
 # SPDX-License-Identifier: BSD-2-Clause
-# Copyright 2014-2025, John McNamara, jmcnamara@cpan.org.
+# Copyright 2014-2026, John McNamara, jmcnamara@cpan.org.
 #
 
 # Keep the output quiet by default.

=== examples/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #
 # Makefile for libxlsxwriter examples.
 #
-# Copyright 2014-2025, John McNamara, jmcnamara@cpan.org
+# Copyright 2014-2026, John McNamara, jmcnamara@cpan.org
 #
 
 # Keep the output quiet by default.

=== src/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Makefile for libxlsxwriter library.
 #
 # SPDX-License-Identifier: BSD-2-Clause
-# Copyright 2014-2025, John McNamara, jmcnamara@cpan.org.
+# Copyright 2014-2026, John McNamara, jmcnamara@cpan.org.
 #
 
 # Keep the output quiet by default.

=== test/cpp/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Makefile for libxlsxwriter testcase.
 #
 # SPDX-License-Identifier: BSD-2-Clause
-# Copyright 2014-2025, John McNamara, jmcnamara@cpan.org.
+# Copyright 2014-2026, John McNamara, jmcnamara@cpan.org.
 #
 
 # Keep the output quiet by default.

=== test/unit/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Makefile for libxlsxwriter library.
 #
 # SPDX-License-Identifier: BSD-2-Clause
-# Copyright 2014-2025, John McNamara, jmcnamara@cpan.org.
+# Copyright 2014-2026, John McNamara, jmcnamara@cpan.org.
 #
 
 # Keep the output quiet by default.

=== test/functional/src/Makefile ===
###############################################################################
#
# Makefile for libxlsxwriter functional test executables.
#
# SPDX-License-Identifier: BSD-2-Clause
# Copyright 2014-2026, John McNamara, jmcnamara@cpan.org.
#

# Keep the output quiet by default.
Q=@
ifdef V
Q=
endif


# Directory variables.
INC_DIR     = ../../../include

# Flags passed to the C++ compiler.
CFLAGS += -g -Wall -Wextra

# Source files to compile.
SRCTESTFILES ?= *.c
SRCS = $(wildcard $(SRCTESTFILES))
EXES = $(patsubst %.c,%,$(SRCS))


ifndef GCOV
LIBXLSXWRITER = ../../../src/libxlsxwriter.a
else
# Link against the same lib used by the unit tests.
LIBXLSXWRITER = ../../../src/libxlsxwriter_test.a
endif


LIBS = $(LIBXLSXWRITER) -lz
ifdef USE_SYSTEM_MINIZIP
LIBS   += -lminizip
CFLAGS += -DUSE_SYSTEM_MINIZIP
endif

ifdef USE_OPENSSL_MD5
LIBS   += -lcrypto
endif

# Use a third party double number formatting function.
ifdef USE_DTOA_LIBRARY
CFLAGS += -DUSE_DTOA_LIBRARY
endif

all : $(LIBXLSXWRITER) $(EXES)

$(LIBXLSXWRITER):
ifndef USE_SYSTEM_MINIZIP
	$(Q)$(MAKE) -C ../../../third_party/minizip
endif
	$(Q)$(MAKE) -C ../../../src

clean :
	$(Q)rm -f $(EXES)
	$(Q)rm -rf *.dSYM *.gcno *.gcda

# Executable targets.
%: %.c $(LIBXLSXWRITER)
	$(Q)$(CC) -I$(INC_DIR) $(CFLAGS) $(LDFLAGS) $(GCOV) $< -o $@ $(LIBS)

test_valgrind: all
	$(Q)$(foreach exe,$(EXES),valgrind -q --error-exitcode=1 --leak-check=full ./$(exe) || exit;)

=== test/unit/app/Makefile ===
###############################################################################
#
# Makefile for libxlsxwriter library.
#
# SPDX-License-Identifier: BSD-2-Clause
# Copyright 2014-2026, John McNamara, jmcnamara@cpan.org.
#

include ../Makefile.unit

=== test/unit/table/Makefile ===
###############################################################################
#
# Makefile for libxlsxwriter library.
#
# Copyright 2014-2026, John McNamara, jmcnamara@cpan.org
#

include ../Makefile.unit

=== debian/changelog ===
libxlsxwriter (1.2.4-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Fri, 16 Jan 2026 13:51:21 -0500

libxlsxwriter (1.2.4-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/control: Bump Standards-Version to 4.7.3.
  * debian: Bump SONAME from 10 to 11.
  * debian/libxlsxwriter11.symbols: Updated.

 -- Boyuan Yang <byang@debian.org>  Tue, 13 Jan 2026 11:39:19 -0500

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: libxlsxwriter
 Section: libs
-Priority: optional
 Maintainer: Ma Aiguo <imaiguo@gmail.com>
 Uploaders:
  Boyuan Yang <byang@debian.org>,
@@ -14,8 +13,7 @@
  python3-dev,
  python3-pytest <!nocheck>,
  zlib1g-dev,
-Standards-Version: 4.7.2
-Rules-Requires-Root: no
+Standards-Version: 4.7.3
 Homepage: https://github.com/jmcnamara/libxlsxwriter
 Vcs-Git: https://salsa.debian.org/debian/libxlsxwriter.git
 Vcs-Browser: https://salsa.debian.org/debian/libxlsxwriter
@@ -30,7 +28,7 @@
 Multi-Arch: same
 Depends:
  libssl-dev,
- libxlsxwriter10 (= ${binary:Version}),
+ libxlsxwriter11 (= ${binary:Version}),
  ${misc:Depends},
 Description: ${source:Synopsis} -- development library of xlsxwriter
  ${source:Extended-Description}
@@ -38,7 +36,7 @@
  This package contains the header file and development library of
  xlsxwriter.
 
-Package: libxlsxwriter10
+Package: libxlsxwriter11
 Architecture: any
 Multi-Arch: same
 Depends:

=== debian/watch ===
Version: 5

Template: GitHub
Owner: jmcnamara
Project: libxlsxwriter
